<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject } from 'vue';
import { storeToRefs } from 'pinia';
import { usePreviewStore } from '@/stores/preview';
import TextView from '@/components/general/TextView.vue';
import Embedded from '@/components/general/Embedded.vue';
import LikeButton from '@/components/general/LikeButton.vue';
import { getFileType } from '@/lib/utils';


const props = defineProps<{
    body?: any,
    info?: any,
    title: any,
    shape?: string,
    color?: string,
    commentsCount?: number
    likes?: number,
    postIndex: number,
    columnIndex?: number,
    id: string
}>();

const configuration = inject<any>('configuration');
const store = usePreviewStore();
const { style, commentsAllowed, likesAllowed, postIndex, columnIndex, isExport } = storeToRefs(store);
const openCommentCanvas = () => {
    postIndex.value = props.postIndex;
    if (props.columnIndex !== undefined)
        columnIndex.value = props.columnIndex;
}

const showTopbar = computed(()=>{
    if(props.body){
        if(props.title.post.toLowerCase().endsWith('.pdf'))
            return true;
        const fileType = getFileType(props.body, props.title.post)
        return (fileType && fileType !== 'misc' && fileType !== 'h5p') || (props.body.image && props.body.logo);
    }
    return false;
});

</script>
<template>
    <div class="relative box-border bg-white text-gray-500 flex flex-col gap-1 shadow-md min-h-20 mr-1"
        :class="[{ 'element': props.columnIndex === undefined }, shape]" :id="id" :style="{ background: color }">
        <div class="px-2 z-10" :class="['tb-' + shape, {'bg-white/80':showTopbar}]">
            <div class="min-h-7 p-1 hyphens-auto w-full max-h-7 text-ellipsis line-clamp-1" lang="de">
                <strong>{{ title.headline }}</strong>
            </div>
        </div>
        <div class="-mt-8" v-if="body">
            <Embedded class="w-full inline" :key="title.post" :body="body" :url="title.post"
                :fontSize="style.fontSize" :info="info" :topbarClass="'tb-' + shape"
                v-if="title.post && title.post.length > 0" :isExport="isExport" :exportApi="isExport ? configuration.exportApi : undefined"/>
        </div>
        <div class="" v-else>
            <TextView :fontSize="style.fontSize" :content="title.post"
                :font-style="style?.font ? style.font : ''" :content-length="-1" />
        </div>
        <div class="flex flex-row justify-between p-1">
            <span class="w-fit" v-if="props.columnIndex === undefined && commentsAllowed && commentsCount!==undefined">
                <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md" @click="openCommentCanvas">
                    <i class="ri-discuss-line leading-5 text-[20px]"></i>
                    <span class="text-xs leading-7 align-bottom" v-if="commentsCount <= 99 && commentsCount > 0">{{
                    commentsCount }}</span>
                    <span class="text-xs leading-7 align-bottom" v-else-if="commentsCount > 99">99+</span>
                </button>
            </span>
            <div v-else-if="likesAllowed">
                <LikeButton :likes="likes" :likeSymbol="style.likeSymbol"/>
            </div>
            <span class="w-fit" v-if="props.columnIndex !== undefined && commentsAllowed && commentsCount!==undefined">
                <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md" @click="openCommentCanvas">
                    <span class="text-xs leading-7 align-bottom" v-if="commentsCount <= 99 && commentsCount > 0">{{
                    commentsCount }}</span>
                    <span class="text-xs leading-7 align-bottom" v-else-if="commentsCount > 99">99+</span>
                    <i class="ri-discuss-line leading-5 text-[20px]"></i>
                </button>
            </span>
        </div>
    </div>
</template>